import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement
local colours={["0"]=Turbine.UI.Color(0.1,0.1,0.1),["1"]=Turbine.UI.Color(0.2,0.2,0.2)}
local voidColours={["1"]=Turbine.UI.Color(0.3,0.3,0.3),["0"]=Turbine.UI.Color(0.4,0.4,0.4)}
local currentColour=Turbine.UI.Color(1,0.1,0.1,0.5)
calendarWidth=1500
calendarHeight=800
calendarWindow=Turbine.UI.Lotro.Window()
calendarWindow:SetText("KinCalendar")
calendarWindow:SetZOrder(10)

calendarWindow:SetSize(calendarWidth,calendarHeight)
calendarWindow:SetPosition(100,100)
calendarWindow:SetVisible(false)

headingHeight=32

	
updateCalendar = function()
	while date["day"] > 1 do
		takeOneDay()
	end
	local dayList = {}
	for i=0,((date["dayOfWeek"]-2)%7) do
		dayList[i]={voidColours[tostring(i%2)],""}
	end
	
	local currentMonth=date["month"]
	local count=0
	while date["month"] == currentMonth do
		if date["day"].."/"..date["month"].."/"..date["year"]== currentDay then
			dayList[#dayList+1]={currentColour,tostring(date["day"])}
		else
			dayList[#dayList+1]={colours[tostring(count)],tostring(date["day"])}
			--print(colours[count])
		end
		count=(count+1)%2
		addOneDay()
	end
	takeOneDay()
	for i=#dayList+1,42 do
		dayList[i]={voidColours[tostring(i%2)],""}

	end


	if calendarList == nil then
		calendarList = Turbine.UI.ListBox()
		calendarList:SetParent(calendarWindow)
		calendarList:SetSize(calendarWidth-100,calendarHeight)
		calendarList:SetPosition(50,50)
		calendarList:SetOrientation(Turbine.UI.Orientation.Vertical)
	end
	calendarList:ClearItems()

	local item = Turbine.UI.ListBox()
	item:SetSize(calendarWidth,headingHeight)
	item:SetOrientation(Turbine.UI.Orientation.Horizontal)
	local ccLabel=Turbine.UI.Label()
	ccLabel:SetSize(100,32)
	ccLabel:SetText("Chat Channel: ")
	ccLabel:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleRight)
	item:AddItem(ccLabel)

	local ccText=Turbine.UI.Lotro.TextBox()
	ccText:SetSize(32,32)
	if data["Channel"] == nil then
		ccText:SetText("Enter Channel Here")
	else
		ccText:SetText(data["Channel"])
	end

	ccText.TextChanged=function()
		data["Channel"]=ccText:GetText()
		Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendar", data);
		setOpenQS()
	end
	item:AddItem(ccText)

	local spacer=Turbine.UI.Control()
	spacer:SetSize(200,headingHeight)
	item:AddItem(spacer)


	local newB = Turbine.UI.Lotro.Button()
	newB:SetText("New Event")
	newB:SetSize(100,32)
	newB.MouseClick=function()
		new()
	end
	item:AddItem(newB)





	local spacer=Turbine.UI.Control()
	spacer:SetSize((calendarWidth-364)/2-432,headingHeight)
	item:AddItem(spacer)
	local leftArrow=Turbine.UI.Button()
	leftArrow:SetSize(32,32)
	leftArrow:SetBackground(0x4110a12f)
	--leftArrow:SetStretchMode(2)
	leftArrow:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	--leftArrow:SetSize(100,100)
	item:AddItem(leftArrow)
	
	--clickyclickyshit
	leftArrow.Click=function()
		currentMonth=date["month"]
		while date["month"]==currentMonth do
			takeOneDay()
		end
		updateCalendar()
	end
	leftArrow.MouseEnter=function()
		leftArrow:SetBackground(0x4110a130)
	end
	leftArrow.MouseLeave=function()
		leftArrow:SetBackground(0x4110a12f)
	end
	leftArrow.MouseDown=function()
		leftArrow:SetBackground(0x4110a131)
	end
	leftArrow.MouseUp=function()
		leftArrow:SetBackground(0x4110a130)
	end




	local label=Turbine.UI.Label()
	label:SetSize(200,headingHeight)
	label:SetText(months[date["month"]].." "..date["year"])
	label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	item:AddItem(label)
	
	local rightArrow=Turbine.UI.Button()
	rightArrow:SetSize(32,32)
	rightArrow:SetBackground(0x4110a132)
	rightArrow:SetBlendMode(Turbine.UI.BlendMode.Overlay)
	--rightArrow:SetSize(100,100)
	item:AddItem(rightArrow)
	
	--clickyclickyshit
	rightArrow.Click=function()
		currentMonth=date["month"]
		while date["month"]==currentMonth do
			addOneDay()
		end
		updateCalendar()
	end
	rightArrow.MouseEnter=function()
		rightArrow:SetBackground(0x4110a133)
	end
	rightArrow.MouseUp=function()
		rightArrow:SetBackground(0x4110a133)
	end
	rightArrow.MouseDown=function()
		rightArrow:SetBackground(0x4110a134)
	end
	rightArrow.MouseLeave=function()
		rightArrow:SetBackground(0x4110a132)
	end







	calendarList:AddItem(item)

	local spacer=Turbine.UI.Control()
	spacer:SetSize((calendarWidth-364)/2,10)
	calendarList:AddItem(spacer)

	local item = Turbine.UI.ListBox()
	item:SetSize(calendarWidth-100,24)
	item:SetOrientation(Turbine.UI.Orientation.Horizontal)
	for i=2,8 do
			local label=Turbine.UI.Label()
			label:SetSize((calendarWidth-100)/7,24)
			label:SetText(days[i%7])
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
			--label:SetBackColor(dayList[(i-1)*7+j][1])	
			item:AddItem(label)
	end
	calendarList:AddItem(item)

	
	for i=1,6 do
		local item = Turbine.UI.ListBox()
		item:SetSize(calendarWidth-100,(calendarHeight-134-headingHeight)/6)
		item:SetOrientation(Turbine.UI.Orientation.Horizontal)

		for j =1,7 do
			local square = Turbine.UI.ListBox()
			square:SetSize((calendarWidth-100)/7,(calendarHeight-134-headingHeight)/6)
			square:SetOrientation(Turbine.UI.Orientation.Vertical)
			
			local label=Turbine.UI.Label()
			label:SetSize((calendarWidth-100)/7,24)
			label:SetText(dayList[(i-1)*7+j][2])
			label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
			label:SetBackColor(dayList[(i-1)*7+j][1])
			square:AddItem(label)


			--event indicators go here
			local key = dayList[(i-1)*7+j][2].."/"..date["month"].."/"..date["year"]
			if data["Other"][key] ~= nil then
				for k in pairs(data["Other"][key]) do
					local text = data["Other"][key][k]["Time"].." "..data["Other"][key][k]["Name"].."("..string.gsub(data["Other"][key][k]["ID"],"^%d+","")..")"
					local label=Turbine.UI.Label()
					label:SetSize((calendarWidth-100)/7,24)
					label:SetText(text)
					label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
					label:SetBackColor(dayList[(i-1)*7+j][1])
					square:AddItem(label)

				end
			end
			

			local label=Turbine.UI.Label()
			label:SetSize((calendarWidth-100)/7,500)
			
			label:SetBackColor(dayList[(i-1)*7+j][1])
			square:AddItem(label)
			item:AddItem(square)

		end
		calendarList:AddItem(item)
	end

			

			
end
	
updateCalendar()	
	
